tinyurl.com -os url "visszafejtése"

Sziasztok!

Van az alábbi PHP script, ami működik egy linuxos gépen, tehát a tinyurl-ról megkapom az eredeti linket (a valami nem valós!!! :)):

<?php

$u = 'https://tinyurl.com/valami';

function reverse_tinyurl($url){
    $url = explode('.com/', $url);
    $url = 'https://preview.tinyurl.com/'.$url[1];
    $preview = file_get_contents($url);
    preg_match('/redirecturl" href="(.*)">/', $preview, $matches);
    return $matches[1];
}

echo '<a href="' . reverse_tinyurl($u) . '">Értekezlet (Google CHROME alatt nyisd meg!!!)</a>';
?>

Ezt szeretném megcsinálni Python alatt, de akárhogy küzdök, nem sikerül.

Próbálom használni a dns.resolver modult, hogy a scripten belül megadjam a DNS szervernek a 8.8.8.8-at, de Timeout-ot dob a script.

 

Van ötletetek? A resolv.conf-ban benne van egyébként a 8.8.8.8

Hozzászólások

preview = requests.get(url)

4 és fél éve csak vim-et használok. elsősorban azért, mert még nem jöttem rá, hogy kell kilépni belőle.

import requests
import re

u = 'https://tinyurl.com/valami'

def reverse_tinyurl(url):
    url = url.split('.com/')
    url = 'https://preview.tinyurl.com/' + url[1]
    preview = requests.get(url).text
    output = re.search('redirecturl" href="(.*)">', preview)
    return output.group(1)

print('<a href="' + reverse_tinyurl(u) + '">Értekezlet (Google CHROME alatt nyisd meg!!!)</a>')

ez ugyan az a kód (ugyanolyan rossz megvalósítással), mint a PHP

4 és fél éve csak vim-et használok. elsősorban azért, mert még nem jöttem rá, hogy kell kilépni belőle.

requests: http (es hasonlo) requesteket kuld
bs4: beautifulsoup, html (meg hasonlo) elemzo, celszeru a html5lib-et vagy hasonlit is feltenni hozza
re: regularis kifejezes modul

Ezekkel a legtobb webes elemzo osszedobhato eleg hamar.

Amugy a php-s megoldasod is csak akkor megy, ha engedelyezik a file_get_contents-hez a http url-ek hasznalatat, ami sok helyen tiltva van. Ilyenkor pl. libcurl-el erheted el ugyanezt.

When you tear out a man's tongue, you are not proving him a liar, you're only telling the world that you fear what he might say. -George R.R. Martin

Szerkesztve: 2021. 11. 29., h – 09:06

Jövő héten próbálom, és beküldöm az esetleges hibákat ill. ha lesz, akkor a megoldást is.

import requests

url = 'https://tinyurl.com/valami'
session = requests.Session()  # so connections are recycled
resp = session.head(url, allow_redirects=True)
print(resp.url)

Forrás: link

Ez sajnos elhasal az alábbi hibákkal:

Traceback (most recent call last):
  File "/usr/lib/python3.6/site-packages/urllib3/connection.py", line 162, in _new_conn
    (self._dns_host, self.port), self.timeout, **extra_kw)
  File "/usr/lib/python3.6/site-packages/urllib3/util/connection.py", line 57, in create_connection
    for res in socket.getaddrinfo(host, port, family, socket.SOCK_STREAM):
  File "/usr/lib64/python3.6/socket.py", line 745, in getaddrinfo
    for res in _socket.getaddrinfo(host, port, family, type, proto, flags):
socket.gaierror: [Errno -2] Name or service not known

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/lib/python3.6/site-packages/urllib3/connectionpool.py", line 600, in urlopen
    chunked=chunked)
  File "/usr/lib/python3.6/site-packages/urllib3/connectionpool.py", line 343, in _make_request
    self._validate_conn(conn)
  File "/usr/lib/python3.6/site-packages/urllib3/connectionpool.py", line 839, in _validate_conn
    conn.connect()
  File "/usr/lib/python3.6/site-packages/urllib3/connection.py", line 315, in connect
    conn = self._new_conn()
  File "/usr/lib/python3.6/site-packages/urllib3/connection.py", line 171, in _new_conn
    self, "Failed to establish a new connection: %s" % e)
urllib3.exceptions.NewConnectionError: <urllib3.connection.VerifiedHTTPSConnection object at 0x7f64f8a52080>: Failed to establish a new connection: [Errno -2] Name or service not known

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/lib/python3.6/site-packages/requests/adapters.py", line 449, in send
    timeout=timeout
  File "/usr/lib/python3.6/site-packages/urllib3/connectionpool.py", line 638, in urlopen
    _stacktrace=sys.exc_info()[2])
  File "/usr/lib/python3.6/site-packages/urllib3/util/retry.py", line 399, in increment
    raise MaxRetryError(_pool, url, error or ResponseError(cause))
urllib3.exceptions.MaxRetryError: HTTPSConnectionPool(host='tinyurl.com', port=443): Max retries exceeded with url: /gfe-tdk-2021 (Caused by NewConnectionError('<urllib3.connection.VerifiedHTTPSConnection object at 0x7f64f8a52080>: Failed to establish a new connection: [Errno -2] Name or service not known',))

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "x.py", line 6, in <module>
    resp = session.head(url, allow_redirects=True)
  File "/usr/lib/python3.6/site-packages/requests/sessions.py", line 568, in head
    return self.request('HEAD', url, **kwargs)
  File "/usr/lib/python3.6/site-packages/requests/sessions.py", line 533, in request
    resp = self.send(prep, **send_kwargs)
  File "/usr/lib/python3.6/site-packages/requests/sessions.py", line 646, in send
    r = adapter.send(request, **kwargs)
  File "/usr/lib/python3.6/site-packages/requests/adapters.py", line 516, in send
    raise ConnectionError(e, request=request)
requests.exceptions.ConnectionError: HTTPSConnectionPool(host='tinyurl.com', port=443): Max retries exceeded with url: /valami (Caused by NewConnectionError('<urllib3.connection.VerifiedHTTPSConnection object at 0x7f64f8a52080>: Failed to establish a new connection: [Errno -2] Name or service not known',))

Péntek éjjel telefonon próbáltam ki, működött.

Most gépen csináltam egy teljesen szűz virtuális környezetet, csupán a requests-et telepítettem fel rá (függőségeivel) és így is működik nálam (hiba nélkül lefut):

(venv) C:\Users\Jacem\Desktop\teszt>python
Python 3.7.1 (v3.7.1:260ec2c36a, Oct 20 2018, 14:05:16) [MSC v.1915 32 bit (Intel)] on win32
Type "help", "copyright", "credits" or "license" for more information.
>>> import requests
>>> url = 'https://tinyurl.com/valami'
>>> session = requests.Session()
>>> resp = session.head(url, allow_redirects=True)
>>> print(resp.url)
https://www.pcguru.hu/pcguru/leiras_vegigj.php?id=43&page=2&nev=vegigjatszas

Kreáltam az eredeti linkeddel egy másik rövidítettet és ezt is "felnyitja" a szkript :)

Az egészet feltettem a pastebin oldalra is.

igy van, siman mukodik, faek egyszeru.

$ python3
Python 3.8.10 (default, Sep 28 2021, 16:10:42)
[GCC 9.3.0] on linux
Type "help", "copyright", "credits" or "license" for more information.
>>> import requests
>>> url = 'https://tinyurl.com/valami'
>>> session = requests.Session()
>>> resp = session.head(url, allow_redirects=True)
>>> print(resp.url)
https://www.pcguru.hu/pcguru/leiras_vegigj.php?id=43&page=2&nev=vegigjatszas

Szerintem a mi hálózatunkban van valamilyen korlátozás erre, illetve észrevettem, hogy a 8.8.8.8 ping-elése átirányítódik, de a 8.8.4.4-et nem engedi a hálózatunk ping-elni. Szerintem a NISZ szivat ilyen szinten.

A pastebin-es url-t sem tudom betölteni, nemhogy a bit.ly-ost :(

Ezért volt furcsa, hogy az általam küldött PHP kód ment amit közzétettem, de nem találtam Python megfelelőjét. A Curl-os változatot kipróbálom.